config/routes.rb
Rails.application.routes.draw do
  devise_for :users

  # Main page (list of all companies)
  root 'companies#index'

  # Companies
  resources :companies
  put '/companies/:id/:action', to: 'companies#upvote', as: 'companies_upvote'
  put '/companies/:id/:action', to: 'companies#downvote', as: 'companies_downvote'

  # Employees (users)
  put '/users/:id/:action', to: 'users#upvote', as: 'users_upvote'
  put '/users/:id/:action', to: 'users#downvote', as: 'users_downvote'

  # Favorites
  get '/favorites', to: 'favorites#index', as: :favorites

end

app/models/user.rb
# == Schema Information
#
# Table name: users
#
#  id                     :integer          not null, primary key
#  username               :string
#  first_name             :string
#  last_name              :string
#  company_id             :integer
#  avatar                 :string
#  profession             :string
#  created_at             :datetime         not null
#  updated_at             :datetime         not null
#  email                  :string           default(""), not null
#  encrypted_password     :string           default(""), not null
#  reset_password_token   :string
#  reset_password_sent_at :datetime
#  remember_created_at    :datetime
#  sign_in_count          :integer          default(0), not null
#  current_sign_in_at     :datetime
#  last_sign_in_at        :datetime
#  current_sign_in_ip     :inet
#  last_sign_in_ip        :inet
#

class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  # One employee in one company
  belongs_to :company

  # Validations
  validates :first_name, :last_name, :email, :company_id, presence: true
  validates :first_name, length: { minimum: 2 } # => Jo Kwan Duk? o_O

  # Likes
  acts_as_votable
  acts_as_voter

  # Likes by current_user
  def self.likes(user)
    likes = []

    user.votes.where(votable_type: 'User').each do |vote|
      likes << find(vote.votable_id)
    end

    likes
  end
end

app/controllers/users_controller.rb
# == Schema Information
#
# Table name: users
#
#  id                     :integer          not null, primary key
#  username               :string
#  first_name             :string
#  last_name              :string
#  company_id             :integer
#  avatar                 :string
#  profession             :string
#  created_at             :datetime         not null
#  updated_at             :datetime         not null
#  email                  :string           default(""), not null
#  encrypted_password     :string           default(""), not null
#  reset_password_token   :string
#  reset_password_sent_at :datetime
#  remember_created_at    :datetime
#  sign_in_count          :integer          default(0), not null
#  current_sign_in_at     :datetime
#  last_sign_in_at        :datetime
#  current_sign_in_ip     :inet
#  last_sign_in_ip        :inet
#

class UsersController < ApplicationController

  # Like person (user) bu current_user
  def upvote
    @user = User.find(params[:id])
    respond_to do |format|
      @user.liked_by current_user
      @user.save
      format.html { redirect_to :back }
      # format.json { render json: { count: @user.votes_for.size } }
      format.js { render layout: false }
    end
  end

  # UnLike person (user) bu current_user
  def downvote
    @user = User.find(params[:id])
    respond_to do |format|
      @user.unliked_by current_user
      @user.save
      format.html { redirect_to :back }
      # format.json { render json: { count: @user.votes_for.size } }
      format.js { render layout: false }
    end
  end

end

app/helpers/users_helper.rb
# == Schema Information
#
# Table name: users
#
#  id                     :integer          not null, primary key
#  username               :string
#  first_name             :string
#  last_name              :string
#  company_id             :integer
#  avatar                 :string
#  profession             :string
#  created_at             :datetime         not null
#  updated_at             :datetime         not null
#  email                  :string           default(""), not null
#  encrypted_password     :string           default(""), not null
#  reset_password_token   :string
#  reset_password_sent_at :datetime
#  remember_created_at    :datetime
#  sign_in_count          :integer          default(0), not null
#  current_sign_in_at     :datetime
#  last_sign_in_at        :datetime
#  current_sign_in_ip     :inet
#  last_sign_in_ip        :inet
#

module UsersHelper
end

app/views/users/_like.slim
div.text-center
  span style="font-size: 22px;"
    = link_to users_upvote_path(user), { method: :put, remote: true, class: "btn-w-img fav-btn item_vote"}
      <i class="ti-heart icon"></i>

app/views/users/_unlike.slim
div.text-center
  span style="font-size: 22px;"
    = link_to users_downvote_path(user), { method: :put, remote: true, class: "main-btn btn-w-img fav-btn item_vote active"}
      <i class="ti-heart icon" style="color: rgba(255, 0, 0, 0.69)"></i>

app/views/users/downvote.js.erb
$('.item_vote').on('ajax:send', function() {
  $(this).addClass('loading');
}).on('ajax:complete', function() {
}).on('ajax:error', function() {
  $(this).after('<div class="error">There was an issue.</div>');
}).on('ajax:success', function(data) {
  $(this).removeClass('spinner spinner-blink');
  $(this).replaceWith("<%= j render partial: 'users/like', locals: {:user => @user } %>");
});

app/views/users/upvote.js.erb
$('.item_vote').bind('ajax:send', function() {
  $(this).addClass('loading');
}).on('ajax:complete', function() {
}).on('ajax:error', function() {
  $(this).after('<div class="error">There was an issue.</div>');
}).on('ajax:success', function(data) {
  $(this).replaceWith("<%= j render partial: 'users/unlike', locals: {:user => @user } %>");
});